datablock AudioProfile(Plasma_RifleFireSound)
{
   filename    = "./fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Plasma_RifleMagInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Plasma_RifleMagOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Plasma_RifleUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Plasma_RifleMagIn_emptySound)
{
   filename    = "./clipIn_e.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(Plasma_RifleCasing)
{
	shapeFile = "./shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//Effects
//Flash
datablock ParticleData(Plasma_RifleflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./Plasma Flash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Plasma_RifleflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Plasma_RifleflashParticle";

   uiName = "Plasma_Rifle Flash";
};

datablock ParticleData(Plasma_RifleExplosionChunkParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 2400;
   lifetimeVarianceMS   = 1300;
   textureName          = "./Plasma Spark";
   spinSpeed		= 5.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "0 1 0.1 1";
   colors[1]     = "0 1 0.1 1";
   colors[2]     = "0.6 0.6 0.6 0.5";
   sizes[0]      = 0.1;
   sizes[1]      = 0.08;
   sizes[2]      = 0;
   times[0]		= 0;
   times[1]		= 1;
   times[2]		= 1.2;
 
   useInvAlpha = true;
};
datablock ParticleEmitterData(Plasma_RifleExplosionChunkEmitter)
{
   lifeTimeMS = 25;

   ejectionPeriodMS = 50;
   periodVarianceMS = 10;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Plasma_RifleExplosionChunkParticle";
};

datablock DebrisData(Plasma_RifleDebris)
{
   emitters = "Plasma_RifleExplosionChunkEmitter";

	shapeFile = "./empty.dts";
	lifetime = 2.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 400.0;
	elasticity = 0.5;
	friction = 0.05;
	numBounces = 5;
	staticOnMaxBounce = false;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 0.6;
};

datablock ExplosionData(Plasma_RifleMuzzleExplosion)
{

   debris = Plasma_RifleDebris;
   debrisNum = 10;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 10;
   debrisVelocityVariance = 10;
   lifeTimeMS = 250;

   //particleEmitter = Plasma_RifleExplosionChunkEmitter;
   //particleDensity = 5;
   //particleRadius = 0.2;
   
   //emitter[0] = Plasma_RifleExplosionChunkEmitter;
   //emitter[1] = Plasma_RifleExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "5.0 6.0 5.0";
   camShakeAmp = "2.0 6.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 3.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 1;
   lightStartColor = "0.0 0.5 0 1";
   lightEndColor = "0.0 0.1 0.0 1";

   damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 0;
   impulseForce = 0;
};

datablock ParticleData(Plasma_RifleExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.0 1 0.0 0.3";
	colors[1]     = "0.0 0.9 0.0 0.1";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(Plasma_RifleExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Plasma_RifleExplosionParticle";

   useEmitterColors = true;
   uiName = "green Dust";
};


datablock ParticleData(Plasma_RifleExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0 1 0.0 0.9";
	colors[1]     = "0 1 0.0 0.2";
	sizes[0]      = 1.5;
	sizes[1]      = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Plasma_RifleExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Plasma_RifleExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Plasma_Rifle Hit Flash";
};

datablock ExplosionData(Plasma_RifleExplosion)
{
   explosionShape = "./Plasburst.dts";
	soundProfile = PlasImpactSound;

   lifeTimeMS = 150;

   particleEmitter = Plasma_RifleExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = Plasma_RifleExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0 1 0 1";
   lightEndColor = "0 1 0.5";
};

AddDamageType("Plasma_Rifle",   '<bitmap:add-ons/Weapon_Fallout_Bundle/Plasma_Rifle/CI_Plasma_Rifle> %1',    '%2 <bitmap:add-ons/Weapon_Fallout_Bundle/Plasma_Rifle/CI_Plasma_Rifle> %1',0.2,1);
datablock ProjectileData(Plasma_RifleProjectile)
{
   projectileShapeName = "./Plasmaball.dts";
   directDamage        = 45;
   directDamageType    = $DamageType::Plasma_Rifle;
   radiusDamageType    = $DamageType::Plasma_Rifle;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = Plasma_RifleExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "Plasma_Rifle beam";
};


datablock ProjectileData(Plasma_RifleMuzzleExplosionProjectile)
{
   projectileShapeName = "./empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::Plasma_Rifle;
   radiusDamageType    = $DamageType::Plasma_Rifle;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = Plasma_RifleMuzzleExplosion;

   muzzleVelocity      = 0;
   velInheritFactor    = 1;
   explodeOnDeath = true;

   armingDelay         = 00;
   lifetime            = 0;
   fadeDelay           = 0;
   bounceElasticity    = 0.5;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "Plasma_Rifle Muzzle Explosion Projectile";
};


//////////
// item //
//////////
datablock ItemData(Plasma_RifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Plasma_Rifle_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Plasma Rifle";
	iconName = "./UI_Plasma_Rifle";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = Plasma_RifleImage;
	canDrop = true;

	maxAmmo = 12;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Plasma_RifleImage)
{
   // Basic Item properties
   shapeFile = "./Plasma_Rifle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.5 1.35 -0.35"; //"0.7 1.2 -0.5"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Plasma_RifleItem;
   ammo = " ";
   projectile = Plasma_RifleProjectile;
   projectileType = Projectile;

	casing = Plasma_RifleCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Plasma_RifleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.5;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= Plasma_RifleUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;

	stateName[19]="preFire";
	stateTimeoutValue[19]			=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= Plasma_RifleFlashEmitter;
	stateEmitterTime[19]				= 0.04;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= Plasma_RifleFireSound;

	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateWaitForTimeout[16]			= true;
	stateSound[16]				= Plasma_RifleFireSound;
	
	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.3;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready2";
	stateTransitionOnNoAmmo[9]		= "Reload";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 1.30;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= Plasma_RifleMagOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 1.75;
	stateSound[11]				= Plasma_RifleMagInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateTransitionOnTimeout[14]		= "Ready2";
	
	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.2;
	stateTransitionOnTimeout[15]		= "Reload";
	
	stateName[22]				= "Reloaded";
	stateTimeoutValue[22]			= 0.01;
	stateScript[22]				= "onReloaded";
	stateTransitionOnTimeout[22]		= "Ready";
	
	//empty reload states
	stateName[23]				= "ReloadE";
	stateTimeoutValue[23]			= 0.85;
	stateScript[23]				= "onReloadStart";
	stateTransitionOnTimeout[23]		= "WaitE";
	stateWaitForTimeout[23]			= true;
	stateSequence[23]			= "clipOut_e";
	stateSound[23]				= Plasma_RifleMagOutSound;
	
	stateName[24]				= "WaitE";
	stateTimeoutValue[24]			= 1.55;
	stateSound[24]				= Plasma_RifleMagIn_emptySound;
	stateScript[24]				= "onReloadWait";
	stateSequence[24]			= "clipIn_e";
	stateTransitionOnTimeout[24]		= "Reloaded";
};

datablock ShapeBaseImageData(Plasma_RifleSightsImage)
{
   shapeFile = "./Plasma_RifleS.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.0 0.75 -0.17"; //-Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = Plasma_RifleItem;
   ammo = " ";
   projectile = Plasma_RifleProjectile;
   projectileType = Projectile;

	casing = Plasma_RifleCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = Plasma_RifleItem.colorShiftColor;//"0.400 0.196 0 1.000";
   
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.001;
	stateTransitionOnTimeout[0]     = "LoadCheckA";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "reloadSequence";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;
	stateSequence[2]                = "ready";

	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= Plasma_RifleFlashEmitter;
	stateEmitterTime[19]				= 0.04;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= Plasma_RifleFireSound;
	
	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateWaitForTimeout[16]			= true;
	stateSound[16]				= Plasma_RifleFireSound;
	
	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.3;
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "ready";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "reloadSequence";
	stateWaitForTimeout[7]			= true;
	
	stateName[8]				= "reloadSequence";
	stateScript[8]				= "setPlasma_RifleReN";
	
	stateName[9]				= "FireLoadCheckA";
	stateScript[9]				= "onLoadCheck";
	stateTimeoutValue[9]			= 0.01;
	stateTransitionOnTimeout[9]		= "FireLoadCheckB";
	
	stateName[10]				= "FireLoadCheckB";
	stateTransitionOnAmmo[10]		= "Ready2";
	stateTransitionOnNoAmmo[10]		= "ReloadWait";
};


function Plasma_RifleImage::onFire(%this,%obj,%slot)
{
	%projectile = Plasma_RifleProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.001;
	}
	else
	{
		%spread = 0.003;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
		
		%projectile = "Plasma_RifleMuzzleExplosionProjectile";
	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
	
		%p = new (%this.projectileType)()
		{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
		};
	MissionCleanup.add(%p);
	}
	return %p;
}

function Plasma_RifleSightsImage::onFire(%this,%obj,%slot)
{ 
	%projectile = Plasma_RifleProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.001;
	}
	else
	{
		%spread = 0.002;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
		
		%projectile = "Plasma_RifleMuzzleExplosionProjectile";
	
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
	
		%p = new (%this.projectileType)()
		{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
		};
	MissionCleanup.add(%p);
	}
	return %p;
}

function Plasma_RifleSightsImage::setPlasma_RifleReN(%this,%obj,%slot)
{
	%obj.mountImage(Plasma_RifleImage, 0, 0, 0);
	%obj.toolAmmo[%obj.currTool] = 0;
}

function Plasma_RifleImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Plasma_RifleImage::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

function Plasma_RifleImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
}

function Plasma_RifleImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function Plasma_RifleImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

function Plasma_RifleSightsImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function Plasma_RifleSightsImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

package Plasma_RifleSightsSwitch
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;
		if(%triggerNum == 4 && %obj.isImageMounted(Plasma_RifleImage) && %val && %obj.toolAmmo[%obj.currTool] != 0)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(Plasma_RifleSightsImage, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}
		else if(%triggerNum == 4 && %obj.isImageMounted(Plasma_RifleSightsImage) && %val)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(Plasma_RifleImage, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}

		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(Plasma_RifleSightsSwitch);