datablock AudioProfile(Reapers_AtomizerFireSound)
{
   filename    = "./fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Reapers_AtomizerFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Reapers_AtomizerMagInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Reapers_AtomizerMagOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Reapers_AtomizerUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Reapers_AtomizerclipOut_emptySound)
{
   filename    = "./clipOut_e.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Reapers_AtomizerclipIn_emptySound)
{
   filename    = "./clipIn_e.wav";
   description = AudioClose3d;
   preload = true;
};


//shell
datablock DebrisData(Reapers_AtomizerCasing)
{
	shapeFile = "./Shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//Effects
//Flash
datablock ParticleData(Reapers_AtomizerflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./LaserFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0 0 0.9";
	colors[1]     = "1 0 0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(Reapers_AtomizerflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Reapers_AtomizerflashParticle";

   uiName = "Reapers_Atomizer Flash";
};

datablock ParticleData(Reapers_AtomizerExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.0 0.0 0.3";
	colors[1]     = "0.9 0.0 0.0 0.1";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(Reapers_AtomizerExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Reapers_AtomizerExplosionParticle";

   useEmitterColors = true;
   uiName = "Reapers_Atomizer Dust";
};


datablock ParticleData(Reapers_AtomizerExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0 0.0 0.9";
	colors[1]     = "1 0 0.0 0.2";
	sizes[0]      = 1.5;
	sizes[1]      = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Reapers_AtomizerExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Reapers_AtomizerExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Reapers_Atomizer Hit Flash";
};

datablock ExplosionData(Reapers_AtomizerExplosion)
{
   //explosionShape = "";
	soundProfile = Reapers_AtomizerImpactSound;

   lifeTimeMS = 150;

   particleEmitter = Reapers_AtomizerExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = Reapers_AtomizerExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};

AddDamageType("Reapers_Atomizer",   '<bitmap:add-ons/Weapon_Fallout_Bundle/Reapers_Atomizer/CI_Reapers_Atomizer> %1',    '%2 <bitmap:add-ons/Weapon_Fallout_Bundle/Reapers_Atomizer/CI_Reapers_Atomizer> %1',0.2,1);
datablock ProjectileData(Reapers_AtomizerProjectile)
{
   projectileShapeName = "./empty.dts";
   directDamage        = 35;
   directDamageType    = $DamageType::Reapers_Atomizer;
   radiusDamageType    = $DamageType::Reapers_Atomizer;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 5;
   brickExplosionMaxVolume = 10;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 15;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 2;
  //particleEmitter     = "Reapers_AtomizerTrailEmitter";
   explosion           = Reapers_AtomizerExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 50;
   bounceFriction      = 0.01;
   isBallistic         = true;
   bounceAngle         = 0; 
   minStickVelocity    = 1000;
   bounceElasticity    = 1000;
   bounceFriction      = 0;
   gravityMod = 0;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "5 0 0";

   uiName = "Reapers_Atomizer bullet";
};

datablock ProjectileData(Reapers_AtomizerFlashProjectile)
{
   projectileShapeName = "./Beam.dts";
   
   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   muzzleVelocity      = 0.1;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 400;
   fadeDelay           = 400;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 4.0;
   lightColor  = "1 0 0";

   uiName = "Beam Flash";
};

//////////
// item //
//////////
datablock ItemData(Reapers_AtomizerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Reapers_Atomizer_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Reaper's Atomizer";
	iconName = "./UI_Reapers_Atomizer";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = Reapers_AtomizerImage;
	canDrop = true;

	maxAmmo = 12;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Reapers_AtomizerImage)
{

	raycastWeaponRange			= 1000;				
	raycastWeaponTargets		= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
	raycastDirectDamage			= 35;
	raycastDirectDamageType		= $DamageType::Reapers_Atomizer;		
	raycastExplosionProjectile	= Reapers_AtomizerTracerProjectile;			
	raycastExplosionSound		= Reapers_AtomizerImpactSound;


   // Basic Item properties
   shapeFile = "./Reapers_Atomizer.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.5 1.2 -0.4"; //0 -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Reapers_AtomizerItem;
   ammo = " ";
   projectile = Reapers_AtomizerTracerProjectile;
   projectileType = Projectile;

	casing = Reapers_AtomizerCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;
	shellVelocity       = 10.0;


   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Reapers_AtomizerItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.5;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= Reapers_AtomizerUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;

	stateName[19]="preFire";
	stateTimeoutValue[19]			=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= Reapers_AtomizerFlashEmitter;
	stateEmitterTime[19]				= 0.04;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]				= Reapers_AtomizerFireSound;

	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateWaitForTimeout[16]			= true;
	//stateSound[16]				= Reapers_AtomizerFireSound;
	
	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.1;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready2";
	stateTransitionOnNoAmmo[9]		= "Reload";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 1.20;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= Reapers_AtomizerMagOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 1.45;
	stateSound[11]				= Reapers_AtomizerMagInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateTransitionOnTimeout[14]		= "Ready2";
	
	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.2;
	stateTransitionOnTimeout[15]		= "Reload";
	
	stateName[22]				= "Reloaded";
	stateTimeoutValue[22]			= 0.01;
	stateScript[22]				= "onReloaded";
	stateTransitionOnTimeout[22]		= "Ready";
	
	//empty reload states
	stateName[23]				= "ReloadE";
	stateTimeoutValue[23]			= 0.85;
	stateScript[23]				= "onReloadStart";
	stateTransitionOnTimeout[23]		= "WaitE";
	stateWaitForTimeout[23]			= true;
	stateSequence[23]			= "clipOut_e";
	stateSound[23]				= Reapers_AtomizerMagOutSound;
	
	stateName[24]				= "WaitE";
	stateTimeoutValue[24]			= 1.55;
	stateSound[24]				= Reapers_AtomizerMagIn_emptySound;
	stateScript[24]				= "onReloadWait";
	stateSequence[24]			= "clipIn_e";
	stateTransitionOnTimeout[24]		= "Reloaded";
};

datablock ShapeBaseImageData(Reapers_AtomizerSightsImage)
{

	raycastWeaponRange			= 1000;				
	raycastWeaponTargets		= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
	raycastDirectDamage			= 35;
	raycastDirectDamageType		= $DamageType::Reapers_Atomizer;		
	raycastExplosionProjectile	= Reapers_AtomizerTracerProjectile;			
	raycastExplosionSound		= Reapers_AtomizerImpactSound;


   // Basic Item properties
   shapeFile = "./Reapers_AtomizerS.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.0 1 -0.25"; //0 -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Reapers_AtomizerItem;
   ammo = " ";
   projectile = Reapers_AtomizerTracerProjectile;
   projectileType = Projectile;

	casing = Reapers_AtomizerCasing;
	shellExitDir        = "-2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;
	shellVelocity       = 10.0;


   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Reapers_AtomizerItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.001;
	stateTransitionOnTimeout[0]     = "LoadCheckA";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "reloadSequence";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;
	stateSequence[2]                = "ready";

	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= Reapers_AtomizerFlashEmitter;
	stateEmitterTime[19]				= 0.04;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]				= Reapers_AtomizerFireSound;
	
	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateWaitForTimeout[16]			= true;
	//stateSound[16]				= Reapers_AtomizerFireSound;
	
	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.1;
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "ready";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "reloadSequence";
	stateWaitForTimeout[7]			= true;
	
	stateName[8]				= "reloadSequence";
	stateScript[8]				= "setReapers_AtomizerReN";
	
	stateName[9]				= "FireLoadCheckA";
	stateScript[9]				= "onLoadCheck";
	stateTimeoutValue[9]			= 0.01;
	stateTransitionOnTimeout[9]		= "FireLoadCheckB";
	
	stateName[10]				= "FireLoadCheckB";
	stateTransitionOnAmmo[10]		= "Ready2";
	stateTransitionOnNoAmmo[10]		= "ReloadWait";
};

function Reapers_AtomizerImage::onFire(%this,%obj,%slot)
{
	%pos = %obj.getTransform();
    %random = getRandom(1,2);
    switch(%random)
   {
      case 1:
         serverplay3d(Reapers_AtomizerFireSound,%pos);
      case 2:
         serverplay3d(Reapers_AtomizerFire2Sound,%pos);
   }
   
	//%obj.PlayAudio(2,Reapers_AtomizerEchoSound);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	
	if(%this.raycastWeaponRange > 0)
	{
		// Directional Math
		%fvec		= %obj.getForwardVector();
		%fX			= getWord(%fvec,0);
		%fY			= getWord(%fvec,1);
		
		%evec		= %obj.getEyeVector();
		%eX			= getWord(%evec,0);
		%eY			= getWord(%evec,1);
		%eZ			= getWord(%evec,2);
		
		%eXY		= mSqrt((%eX * %eX) + (%eY * %eY));
		%aimVec		= (%fX * %eXY) SPC (%fY * %eXY) SPC %eZ;
		
		// Range
		%range		= %this.raycastWeaponRange * getWord(%obj.getScale(), 2);
		
		if(%range >= 100)
		{
			%rangeRem = %range - 100;
			%range = 100;
		}
		
		// Raycast Parameters
		%start		= %obj.getEyePoint();
		%end[0]		= vectorAdd(%start, vectorScale(%aimVec, %range)); // [0] required for loop
		%targets	= %this.raycastWeaponTargets;
		
		// Raycasting
		%ray		= ContainerRayCast(%start, %end[0], %targets, %obj);
		%col		= getWord(%ray, 0);
		
		if(isObject(%col))
		{
			%pos	= posFromRaycast(%ray);
			%normal	= normalFromRaycast(%ray);
			%end[0]	= %pos;
			%colclass	= %col.getClassName();
			%objsHit++;
			
			%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
			
			if(%colclass $= "Player" || %colclass $= "AIPlayer")
			{
				if(%col.getState() $= "Dead")
				{
					%objsKilled++;
				}
			}
		}
		
		if(%rangeRem > 0)
		{
			for(%a = 1; %a <= 10 && %rangeRem > 0; %a++)
			{
				%range		= %rangeRem;
				
				if(%range >= 100)
				{
					%rangeRem = %range - 100;
					%range = 100;
				}
				
				%start[%a]	= %end[%a - 1];
				%end[%a]	= vectorAdd(%start[%a], vectorScale(%aimVec, %range)); 
				
				%ray		= ContainerRayCast(%start[%a], %end[%a], %targets, %obj);
				%col		= getWord(%ray, 0);
				
				if(isObject(%col))
				{
					%pos		= posFromRaycast(%ray);
					%normal		= normalFromRaycast(%ray);
					%end[%a]	= %pos;
					%colclass	= %col.getClassName();
					%objsHit++;
					
					%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
					
					if(%colclass $= "Player" || %colclass $= "AIPlayer")
					{
						if(%col.getState() $= "Dead")
						{
							%objsKilled++;
						}
					}
					
					if(%objsHit >= 2)
					{
						break;
					}
				}
			}
		}
		
		if(%objsKilled >= 2 && isObject(%client = %obj.client))
		{
			commandToClient(%client, 'bottomPrint', "<color:ff0000>Nice Shot! <color:ffffff>" @ %objsKilled @ " kills in one shot!", 5);
		}
	}
	else
	{
		return Parent::onFire(%this, %obj, %slot);
	}
	
	%projectile = "Reapers_AtomizerFlashProjectile";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}

function Reapers_AtomizerSightsImage::onFire(%this,%obj,%slot)
{
		%pos = %obj.getTransform();
    %random = getRandom(1,2);
    switch(%random)
   {
      case 1:
         serverplay3d(Reapers_AtomizerFireSound,%pos);
      case 2:
         serverplay3d(Reapers_AtomizerFire2Sound,%pos);
   }
   
	//%obj.PlayAudio(2,Reapers_AtomizerEchoSound);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	
	if(%this.raycastWeaponRange > 0)
	{
		// Directional Math
		%fvec		= %obj.getForwardVector();
		%fX			= getWord(%fvec,0);
		%fY			= getWord(%fvec,1);
		
		%evec		= %obj.getEyeVector();
		%eX			= getWord(%evec,0);
		%eY			= getWord(%evec,1);
		%eZ			= getWord(%evec,2);
		
		%eXY		= mSqrt((%eX * %eX) + (%eY * %eY));
		%aimVec		= (%fX * %eXY) SPC (%fY * %eXY) SPC %eZ;
		
		// Range
		%range		= %this.raycastWeaponRange * getWord(%obj.getScale(), 2);
		
		if(%range >= 100)
		{
			%rangeRem = %range - 100;
			%range = 100;
		}
		
		// Raycast Parameters
		%start		= %obj.getEyePoint();
		%end[0]		= vectorAdd(%start, vectorScale(%aimVec, %range)); // [0] required for loop
		%targets	= %this.raycastWeaponTargets;
		
		// Raycasting
		%ray		= ContainerRayCast(%start, %end[0], %targets, %obj);
		%col		= getWord(%ray, 0);
		
		if(isObject(%col))
		{
			%pos	= posFromRaycast(%ray);
			%normal	= normalFromRaycast(%ray);
			%end[0]	= %pos;
			%colclass	= %col.getClassName();
			%objsHit++;
			
			%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
			
			if(%colclass $= "Player" || %colclass $= "AIPlayer")
			{
				if(%col.getState() $= "Dead")
				{
					%objsKilled++;
				}
			}
		}
		
		if(%rangeRem > 0)
		{
			for(%a = 1; %a <= 10 && %rangeRem > 0; %a++)
			{
				%range		= %rangeRem;
				
				if(%range >= 100)
				{
					%rangeRem = %range - 100;
					%range = 100;
				}
				
				%start[%a]	= %end[%a - 1];
				%end[%a]	= vectorAdd(%start[%a], vectorScale(%aimVec, %range)); 
				
				%ray		= ContainerRayCast(%start[%a], %end[%a], %targets, %obj);
				%col		= getWord(%ray, 0);
				
				if(isObject(%col))
				{
					%pos		= posFromRaycast(%ray);
					%normal		= normalFromRaycast(%ray);
					%end[%a]	= %pos;
					%colclass	= %col.getClassName();
					%objsHit++;
					
					%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
					
					if(%colclass $= "Player" || %colclass $= "AIPlayer")
					{
						if(%col.getState() $= "Dead")
						{
							%objsKilled++;
						}
					}
					
					if(%objsHit >= 2)
					{
						break;
					}
				}
			}
		}
		
		if(%objsKilled >= 2 && isObject(%client = %obj.client))
		{
			commandToClient(%client, 'bottomPrint', "<color:ff0000>Nice Shot! <color:ffffff>" @ %objsKilled @ " kills in one shot!", 5);
		}
	}
	else
	{
		return Parent::onFire(%this, %obj, %slot);
	}
	
	%projectile = "Reapers_AtomizerFlashProjectile";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}

function Reapers_AtomizerImageScoped::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %objsHit)
{ 
	if(%this.raycastDirectDamage > 0 && %col.getType() & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
	{
		if(miniGameCanDamage(%obj, %col) == 1 && !%col.getDatablock().indestructable)
		{
			if(%this.raycastDirectDamageType)
			{
				%damageType = %this.raycastDirectDamageType;
			}
			else
			{
				%damageType = $DamageType::Direct;
			}
			
			%scale			= %obj.getScale();
			%scaleFactor	= (getWord(%scale, 0) + getWord(%scale, 1) + getWord(%scale, 2)) / 3;
			%damFloat		= mClampF(%this.raycastDirectDamage, -100, 100);
			%directDamage	= (%damFloat * %scaleFactor) / %objsHit;
			
			%col.damage(%obj, %pos, %directDamage, %damageType);
		}
	}
	
	if(isObject(%this.raycastExplosionProjectile))
	{
		%scale			= %obj.getScale();
		%scaleFactor	= ((getWord(%scale, 0) + getWord(%scale, 1) + getWord(%scale, 2)) / 3) / %objsHit;
		
		%p = new Projectile()
		{
			dataBlock		= %this.raycastExplosionProjectile;
			initialPosition	= %pos;
			initialVelocity	= %normal;
			sourceObject	= %obj;
			client			= %obj.client;
			sourceSlot		= 0;
			originPoint		= %pos;
		};
		
		MissionCleanup.add(%p);
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
		%p.explode();
	}
	
	if(isObject(%this.raycastExplosionSound))
	{
		serverplay3d(%this.raycastExplosionSound, %pos);
	}
}

function Reapers_AtomizerSightsImage::setReapers_AtomizerReN(%this,%obj,%slot)
{
	%obj.mountImage(Reapers_AtomizerImage, 0, 0, 0);
	%obj.toolAmmo[%obj.currTool] = 0;
}

function Reapers_AtomizerImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Reapers_AtomizerImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
}
package Reapers_AtomizerSightsSwitch
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;
		if(%triggerNum == 4 && %obj.isImageMounted(Reapers_AtomizerImage) && %val && %obj.toolAmmo[%obj.currTool] != 0)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(Reapers_AtomizerSightsImage, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}
		else if(%triggerNum == 4 && %obj.isImageMounted(Reapers_AtomizerSightsImage) && %val)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(Reapers_AtomizerImage, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}

		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(Reapers_AtomizerSightsSwitch);

function Reapers_AtomizerImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function Reapers_AtomizerImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

function Reapers_AtomizerSightsImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function Reapers_AtomizerSightsImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}