datablock AudioProfile(Weathered10MM_PistolFireSound)
{
   filename    = "./fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Weathered10MM_PistolMagInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Weathered10MM_PistolMagOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Weathered10MM_PistolUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Weathered10MM_PistolMagIn_emptySound)
{
   filename    = "./clipIn_e.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(Weathered10MM_PistolCasing)
{
	shapeFile = "./shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//Effects
//Flash
datablock ParticleData(Weathered10MM_PistolflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./M45Flash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 1.0;
	sizes[1]      = 1.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Weathered10MM_PistolflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Weathered10MM_PistolflashParticle";

   uiName = "Weathered10MM_Pistol Flash";
};

AddDamageType("Weathered10MM_Pistol",   '<bitmap:add-ons/Weapon_Fallout_Bundle/Weathered10MM_Pistol/CI_Weathered10MM_Pistol> %1',    '%2 <bitmap:add-ons/Weapon_Fallout_Bundle/Weathered10MM_Pistol/CI_Weathered10MM_Pistol> %1',0.2,1);
datablock ProjectileData(Weathered10MM_PistolProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 25;
   directDamageType    = $DamageType::Weathered10MM_Pistol;
   radiusDamageType    = $DamageType::Weathered10MM_Pistol;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "Weathered10MM_Pistol Bullet";
};

//////////
// item //
//////////
datablock ItemData(Weathered10MM_PistolItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Weathered10MM_Pistol_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Weathered 10MM Pistol";
	iconName = "./UI_Weathered10MM_Pistol";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = Weathered10MM_PistolImage;
	canDrop = true;

	maxAmmo = 12;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Weathered10MM_PistolImage)
{
   // Basic Item properties
   shapeFile = "./Weathered10MM_Pistol.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.4 1.25 -0.3"; //"0.7 1.2 -0.5"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Weathered10MM_PistolItem;
   ammo = " ";
   projectile = Weathered10MM_PistolProjectile;
   projectileType = Projectile;

	casing = Weathered10MM_PistolCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Weathered10MM_PistolItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.5;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= Weathered10MM_PistolUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;

	stateName[19]="preFire";
	stateTimeoutValue[19]			=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= Weathered10MM_PistolFlashEmitter;
	stateEmitterTime[19]				= 0.04;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= Weathered10MM_PistolFireSound;

	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateWaitForTimeout[16]			= true;
	stateSound[16]				= Weathered10MM_PistolFireSound;
	
	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.1;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready2";
	stateTransitionOnNoAmmo[9]		= "ReloadE";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.85;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= Weathered10MM_PistolMagOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 0.95;
	stateSound[11]				= Weathered10MM_PistolMagInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateTransitionOnTimeout[14]		= "Ready2";
	
	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.2;
	stateTransitionOnTimeout[15]		= "ReloadE";
	
	stateName[22]				= "Reloaded";
	stateTimeoutValue[22]			= 0.01;
	stateScript[22]				= "onReloaded";
	stateTransitionOnTimeout[22]		= "Ready";
	
	//empty reload states
	stateName[23]				= "ReloadE";
	stateTimeoutValue[23]			= 0.70;
	stateScript[23]				= "onReloadStart";
	stateTransitionOnTimeout[23]		= "WaitE";
	stateWaitForTimeout[23]			= true;
	stateSequence[23]			= "clipOut_e";
	stateSound[23]				= Weathered10MM_PistolMagOutSound;
	
	stateName[24]				= "WaitE";
	stateTimeoutValue[24]			= 1.65;
	stateSound[24]				= Weathered10MM_PistolMagIn_emptySound;
	stateScript[24]				= "onReloadWait";
	stateSequence[24]			= "clipIn_e";
	stateTransitionOnTimeout[24]		= "Reloaded";
};

datablock ShapeBaseImageData(Weathered10MM_PistolSightsImage)
{
   shapeFile = "./Weathered10MM_PistolS.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.0 1.4 -0.22"; //-Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = Weathered10MM_PistolItem;
   ammo = " ";
   projectile = Weathered10MM_PistolProjectile;
   projectileType = Projectile;

	casing = Weathered10MM_PistolCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = Weathered10MM_PistolItem.colorShiftColor;//"0.400 0.196 0 1.000";
   
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.001;
	stateTransitionOnTimeout[0]     = "LoadCheckA";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "reloadSequence";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;
	stateSequence[2]                = "ready";

	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= Weathered10MM_PistolFlashEmitter;
	stateEmitterTime[19]				= 0.04;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= Weathered10MM_PistolFireSound;
	
	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateWaitForTimeout[16]			= true;
	stateSound[16]				= Weathered10MM_PistolFireSound;
	
	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.1;
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "ready";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "reloadSequence";
	stateWaitForTimeout[7]			= true;
	
	stateName[8]				= "reloadSequence";
	stateScript[8]				= "setWeathered10MM_PistolReN";
	
	stateName[9]				= "FireLoadCheckA";
	stateScript[9]				= "onLoadCheck";
	stateTimeoutValue[9]			= 0.01;
	stateTransitionOnTimeout[9]		= "FireLoadCheckB";
	
	stateName[10]				= "FireLoadCheckB";
	stateTransitionOnAmmo[10]		= "Ready2";
	stateTransitionOnNoAmmo[10]		= "ReloadWait";
};


function Weathered10MM_PistolImage::onFire(%this,%obj,%slot)
{
	%projectile = Weathered10MM_PistolProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.0002;
	}
	else
	{
		%spread = 0.0003;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function Weathered10MM_PistolSightsImage::setWeathered10MM_PistolReN(%this,%obj,%slot)
{
	%obj.mountImage(Weathered10MM_PistolImage, 0, 0, 0);
	%obj.toolAmmo[%obj.currTool] = 0;
}

function Weathered10MM_PistolSightsImage::onFire(%this,%obj,%slot)
{
	%projectile = Weathered10MM_PistolProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.0001;
	}
	else
	{
		%spread = 0.0002;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function Weathered10MM_PistolSightsImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Weathered10MM_PistolImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Weathered10MM_PistolImage::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

function Weathered10MM_PistolImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
}

package Weathered10MM_PistolSightsSwitch
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;
		if(%triggerNum == 4 && %obj.isImageMounted(Weathered10MM_PistolImage) && %val && %obj.toolAmmo[%obj.currTool] != 0)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(Weathered10MM_PistolSightsImage, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}
		else if(%triggerNum == 4 && %obj.isImageMounted(Weathered10MM_PistolSightsImage) && %val)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(Weathered10MM_PistolImage, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}

		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
};
activatePackage(Weathered10MM_PistolSightsSwitch);

function Weathered10MM_PistolImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function Weathered10MM_PistolImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

function Weathered10MM_PistolSightsImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function Weathered10MM_PistolSightsImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}